#include <cstdio>
#include <cstring>
#include <cmath>
using namespace std;

const int maxp=1000;
double x[2][maxp], y[2][maxp];
int n[2];

int ccw(double x0, double y0, double x1, double y1, double x2, double y2)
{
 double dx1=x1-x0; double dy1=y1-y0;
 double dx2=x2-x0; double dy2=y2-y0;
 double v=dx1*dy2-dy1*dx2;
 if(v>0.0)return 1;
 if(v<0.0)return -1;
 else return 0;
}

int main(int argc, char *argv[])
{
 FILE * fi;
 FILE * fa;

 if (argc != 3)
 {
  printf("bw_checker input_file competitor_answer");
  return 0;
 }

 fi = fopen(argv[1], "r");	// input file
 if (fi == NULL)
 {
	printf("0\nCannot open input.\n");
	return 0;
 }
 fa = fopen(argv[2], "r");	//help file
 if (fa == NULL)
 {
  printf("0\n%s\n no competitor_answer_file\n", argv[2]);
  return 0;
 }


  for(int j=0;j<=1;j++)
  {
   fscanf(fi,"%d",&n[j]);
   // printf("%d\n",n[j]);
   for(int i=1;i<=n[j];i++) fscanf(fi,"%lf%lf",&x[j][i],&y[j][i]);
  }


   double px, py, vx, vy;
   
   if(fscanf(fa,"%lf",&px)<0)
    {printf("0\nno competitor_1st value\n");return 0;};
   
   if(fscanf(fa,"%lf",&py)<0)
    {printf("0\nno competitor_2nd value\n");return 0;};
    
   if(fscanf(fa,"%lf",&vx)<0)
    {printf("0\nno competitor_3rd value\n");return 0;};
    
   if(fscanf(fa,"%lf",&vy)<0)
    {printf("0\nno competitor_4th value\n");return 0;};

   //printf("%lf %lf %lf %lf\n", px, py, vx, vy);
   
   if((vx==0.0)&&(vy==0.0))
    {
      printf("0\n");
      printf("Incorrect\n");
      return 0;
    }
   
   
   if((vx<-1.0)||(vx>1.0)||(vy<-1.0)||(vy>1.0))
    {
      printf("0\n");
      printf("Incorrect\n");
      return 0;
    }
   
   
   if((px<-1000.0)||(px>1000.0)||(py<-1000.0)||(py>1000.0))
    {
      printf("0\n");
      printf("Incorrect\n");
      return 0;
    }

   
   int c[2][2]={{0,0},{0,0}};

   for(int j=0;j<=1;j++)
   {
    for(int i=1;i<=n[j];i++)
    {
      int v=ccw(x[j][i],y[j][i],px,py,px+vx,py+vy);
      if(v==1) c[j][0]++;
      if(v==-1) c[j][1]++;
      if(v==0) {printf("0\nLine goes through a point\n");return 0;};
    }
   }
    
   //printf("%d %d %d %d\n", c[0][0],c[0][1],c[1][0],c[1][1]);
    
    if((c[0][0]==c[0][1])&&(c[1][0]==c[1][1]))
    {
     printf("10\n");
     printf("Correct solution.\n"); return 0;
    }

    printf("0\n");
    printf("Incorrect\n");
 
   return 0;
}
